Sign in

Get started with a Tiptap text editor using Liveblocks and React

Liveblocks is a realtime collaboration infrastructure for building performant collaborative experiences. Follow the following steps to start adding collaboration to your React application using the APIs from the @liveblocks/react-tiptap package.

Quickstart

  1. Install Liveblocks and Tiptap

    Every Liveblocks package should use the same version.

    Terminal
    npm install @liveblocks/client @liveblocks/react @liveblocks/react-ui @liveblocks/react-tiptap @tiptap/react @tiptap/starter-kit
  2. Initialize the liveblocks.config.ts file

    We can use this file later to define types for our application.

    Terminal
    npx create-liveblocks-app@latest --init --framework react
  3. Set up the Liveblocks client

    Liveblocks uses the concept of rooms, separate virtual spaces where people collaborate, and to create a realtime experience, multiple users must be connected to the same room. Set up a Liveblocks client with LiveblocksProvider, and join a room with RoomProvider.

    App.tsx
    "use client";
    import { LiveblocksProvider, RoomProvider,} from "@liveblocks/react/suspense";import { Editor } from "./Editor";
    export default function App() { return ( <LiveblocksProvider publicApiKey={""}> <RoomProvider id="my-room"> {/* ... */} </RoomProvider> </LiveblocksProvider> );}
  4. Join a Liveblocks room

    After setting up the room, you can add collaborative components inside it, using ClientSideSuspense to add loading spinners to your app.

    App.tsx
    "use client";
    import { LiveblocksProvider, RoomProvider, ClientSideSuspense,} from "@liveblocks/react/suspense";import { Editor } from "./Editor";
    export default function App() { return ( <LiveblocksProvider publicApiKey={""}> <RoomProvider id="my-room"> <ClientSideSuspense fallback={<div>Loading…</div>}> <Editor /> </ClientSideSuspense> </RoomProvider> </LiveblocksProvider> );}
  5. Set up the collaborative Tiptap text editor

    Now that we set up Liveblocks, we can start integrating Tiptap and Liveblocks in the Editor.tsx file. To make the editor collaborative, we can add useLiveblocksExtension from @liveblocks/react-tiptap. FloatingToolbar adds a text selection toolbar.

    Editor.tsx
    "use client";
    import { useLiveblocksExtension, FloatingToolbar } from "@liveblocks/react-tiptap";import { useEditor, EditorContent } from "@tiptap/react";import StarterKit from "@tiptap/starter-kit";import { Threads } from "./Threads";
    export function Editor() { const liveblocks = useLiveblocksExtension();
    const editor = useEditor({ extensions: [ liveblocks, StarterKit.configure({ // The Liveblocks extension comes with its own history handling undoRedo: false, }), ], });
    return ( <div> <EditorContent editor={editor} className="editor" /> <Threads editor={editor} /> <FloatingToolbar editor={editor} /> </div> );}
  6. Render threads and composer

    To add Comments to your text editor, we need to import a thread composer and list each thread on the page. Create a Threads.tsx file that uses FloatingComposer for creating new threads, alongside AnchoredThreads and FloatingThreads for displaying threads on desktop and mobile.

    Threads.tsx
    import { useThreads } from "@liveblocks/react/suspense";import {  AnchoredThreads,  FloatingComposer,  FloatingThreads,} from "@liveblocks/react-tiptap";import { Editor } from "@tiptap/react";
    export function Threads({ editor }: { editor: Editor | null }) { const { threads } = useThreads({ query: { resolved: false } });
    return ( <> <div className="anchored-threads"> <AnchoredThreads editor={editor} threads={threads} /> </div> <FloatingThreads editor={editor} threads={threads} className="floating-threads" /> <FloatingComposer editor={editor} className="floating-composer" /> </> );}
  7. Style your editor

    Tiptap text editor is unstyled by default, so we can create some custom styles for it in a globals.css file. Import globals.css, alongside the default Liveblocks styles. You can import them into the root layout of your app or directly into a CSS file with @import.

    app/layout.tsx
    import "@liveblocks/react-ui/styles.css";import "@liveblocks/react-tiptap/styles.css";import "./globals.css";
  8. Next: authenticate and add your users

    Text Editor is set up and working now, but each user is anonymous—the next step is to authenticate each user as they connect, and attach their name, color, and avatar, to their cursors and mentions.

    Add your users to Text Editor

  9. Optional: add more features

    Tiptap is easy to extend, and a number of extensions are already available, making it possible to quickly create complex rich-text applications. For example you can enable features such as tables, text highlights, embedded images, and more. This is all supported using Liveblocks.

    Find more extensions

What to read next

Congratulations! You now have set up the foundation for your collaborative Tiptap text editor inside your React application.


Examples using Tiptap

Sign in

Get started with a Tiptap text editor using Liveblocks and Vue.js

Liveblocks is a realtime collaboration infrastructure for building performant collaborative experiences. Follow the following steps to start adding collaboration to your Vue.js application using the APIs from the @liveblocks/yjs package.

Quickstart

  1. Install Liveblocks, Yjs, and Tiptap

    Every Liveblocks package should use the same version.

    Terminal
    npm install @liveblocks/client @liveblocks/yjs yjs @tiptap/vue-3 @tiptap/pm @tiptap/starter-kit @tiptap/extension-collaboration @tiptap/extension-collaboration-cursor y-prosemirror
  2. Initialize the liveblocks.config.ts file

    We can use this file later to define types for our application.

    Terminal
    npx create-liveblocks-app@latest --init --framework javascript
  3. Set up your collaborative Tiptap text editor

    Editor.vue
    <script setup>import { onUnmounted } from "vue";import { createClient } from "@liveblocks/client";import { getYjsProviderForRoom } from "@liveblocks/yjs";import * as Y from "yjs";import { useEditor, EditorContent } from "@tiptap/vue-3";import StarterKit from "@tiptap/starter-kit";import Collaboration from "@tiptap/extension-collaboration";import CollaborationCursor from "@tiptap/extension-collaboration-cursor";
    const leave = ref(null);
    // Set up Liveblocks clientconst client = createClient({ publicApiKey: "",});
    // Enter a multiplayer roomconst info = client.enterRoom("my-room");const room = info.room;leave.value = info.leave;
    // Set up Yjs document and Liveblocks Yjs providerconst yProvider = getYjsProviderForRoom(room);const yDoc = yProvider.getYDoc();
    // Set up the Tiptap editorconst editor = useEditor({ element, extensions: [ StarterKit.configure({ // The Collaboration extension comes with its own history handling undoRedo: false, }), // Register the Yjs document with Tiptap Collaboration.configure({ document: yDoc, }), CollaborationCursor.configure({ provider: yProvider, }), ],});
    onUnmounted(() => { leave?.();});</script>
    <template> <editor-content :editor="editor" /></template>
  4. Next: set up authentication

    By default, Liveblocks is configured to work without an authentication endpoint where everyone automatically has access to rooms. This approach is great for prototyping and marketing pages where setting up your own security isn’t always required. If you want to limit access to a room for certain users, you’ll need to set up an authentication endpoint to enable permissions.

    Set up authentication

What to read next

Congratulations! You now have set up the foundation for your collaborative Tiptap text editor inside your Vue.js application.